/****************************************************************************/
/****************************************************************************/
/*************** Simplification of Boolean Function *************************/
/***************     and computer analyses of       *************************/
/***************  Quine-McCluskey Tabular Method    *************************/
/****************************************************************************/
/****************************************************************************/

/*
  This program calculates n variable Boolean Function by using Quine-McCluskey
  Tabular algorithm in the form of 'Sum of Products' (SOP).

  By Ahmet Bingul 28.03.2001, Gazinatep MYO

*/


#include <stdio.h>
#include <math.h>               /* function prototypes */
#include <ctype.h>
#define total(n) (n*(n-1))/(2)

main(){

int  i,j,k,l,t,a,b,s,z,N,f,g,term,count,counter,min_num,dont_num,MD;
int  PIlimit,EPIlimit,NEPIlimit,NEPIcount,pair,pair_upper_limit;
int  MIN[64],DONT[64],sayi[100],order[300];
int  DV[64][300],q[300],V[64][64][6],M[64][6],x[6][64],m[64][6];
int  PI[100],PJ[100],I[300],J[300],EPI[50],EPJ[50],NEPI[50],NEPJ[50];
int  CNE[50],CNNE[50];
char C[300][10],CPI[50][10],CEPI[30][10],CNEPI[30][10],CADM[30][10];

clrscr();
puts("Simplification of Boolean Functions.");
puts("Please read the ReadMe file to use this program !\n");
printf("Function Order :");scanf("%d",&N);

/******************** starting production of minterms **********************/
for(i=0;i<N;i++){
for(j=0;j<pow(2,N);){
for(k=0;k<2;k++){
for(l=0;l<pow(2,N-i-1);l++){
                            x[i][j]=k;j++;
                           }
}
}
}
count=0;
do{
for(i=0;i<pow(2,N);i++){
for(j=0;j<N;j++){
                  m[i][j]=x[j][i];
                }
                count++;
                }
}while(count<pow(2,N));

/********************** reading minterms and dont cares **********************/

printf("Minterm    # :");scanf("%d",&min_num);
printf("Dont cares # :");scanf("%d",&dont_num);
MD=(int) min_num+dont_num;
printf("Minterms\n--------------\n");
for(i=0;i<min_num;i++){
printf("%d.Minterms   :",i+1);scanf("%d",&MIN[i]);
}
printf("Dont cares\n---------------\n");
for(j=0;j<dont_num;j++){
printf("%d.Dont cares :",j+1);scanf("%d",&DONT[j]);
}
for(i=min_num;i<20;i++) { MIN[i]=114+i;  }
for(i=dont_num;i<20;i++){ DONT[i]=345+i; }
counter=0;
do{
   for(i=0;i<20;){
   for(j=0;j<20;){
        if(MIN[i]<DONT[j])  { sayi[counter]=(int) MIN[i];i++;  }
                     else   { sayi[counter]=(int) DONT[j];j++; }
   counter++;
   }
   }
}while(counter<MD);

clrscr();

printf("Function Order : %d\n",N);
printf("Minterms       : ");
for(i=0;i<min_num;i++){printf("%d ",MIN[i]);}

printf("\nDon't Cares    : ");
if(dont_num==0){ printf("*** NONE ***");}
if(dont_num!=0){
   for(i=0;i<dont_num;i++){
    printf("%d ",DONT[i]);
   }
}
printf("\n");
for(i=0;i<=10;i++){printf("-------");}

/************************ PROCDUCTION OF THE CELLS *************************/

for(k=0;k<total(MD);k++){ order[k]=0; }
 for(k=0;k<total(MD);){
  for(j=0;j<(MD-1);j++){
   for(l=1;l<=(MD-j-1);l++){
    for(i=0;i<N;i++){
      M[k][i]=(m[sayi[j]][i])*(m[sayi[MD-l]][i]);
      if(M[k][i]!=m[sayi[j]][i])   { break;}
      if(M[k][i]!=m[sayi[MD-l]][i]){ C[k][i]='-';order[k]++;}
               else if(M[k][i]==1) { C[k][i]='1'; }
               else if(M[k][i]==0) { C[k][i]='0'; }
    }
     k++;
  }
 }
}

for(k=0;k<total(MD);k++){
 for(j=0;j<pow(2,order[k]);j++){
 DV[j][k]=0;
  for(l=N-1;l>((N-1)-order[k]);){
  for(i=0;i<N;i++){
                     if(C[k][i]=='1') {V[j][k][i]=1;}
                else if(C[k][i]=='0') {V[j][k][i]=0;}
                else if(C[k][i]=='-') {
                                       V[j][k][i]=x[l][j];l--;
                                      }
                else {V[j][k][i]=-1000;}
  DV[j][k]+=V[j][k][i]*pow(2,N-1-i);
  }
  }
 }
}

/************************ PI CANDIDATE TABLE *************************/

for(k=0;k<total(MD);k++){q[k]=0;}
 for(k=0;k<total(MD);k++){
  for(i=0;i<pow(2,order[k]);i++){
   for(j=0;j<MD;j++){
          if(DV[i][k]!=sayi[j]) { continue;     }
     else if(DV[i][k]==sayi[j]) { q[k]++;break; }
   }
  }
 }
pair=0;
for(k=0;k<total(MD);){
 for(j=0;j<(MD-1);j++){
  for(l=1;l<=(MD-j-1);l++){
   if(q[k]==pow(2,order[k])){
   I[pair]=sayi[j];J[pair]=sayi[MD-l];
   pair++;
   k++;
   }

  else if(q[k]!=pow(2,order[k])) { k++;continue; }
 }
 }
pair_upper_limit=pair;
}

/******************************** PI Table ********************************/

gotoxy(4,6);printf("PI Table");
PI[0]=I[0];PJ[0]=J[0];
printf("\n");
z=1;PIlimit=1;
for(k=0;k<pair_upper_limit;){
g=0;
for(j=0;j<z;j++){
     if(PI[j]> I[k] || I[k]>J[k]  || J[k]> PJ[j])
     {g++;continue;}
else if(PI[j]<=I[k] && I[k]<=J[k] && J[k]<=PJ[j]){
f=0;
for(i=0;i<N;i++){
if(m[PI[j]][i]*m[I[k]][i]==m[PI[j]][i] && m[J[k]][i]*m[PJ[j]][i]==m[J[k]][i])
{
 f++;
 if(i<N) { continue; }
}
else    {g++;break; }
} /* for i */
if(f==N){ k++;break; }
}/*else if*/
} /* for j */
if(g==z){
          PI[z]=I[k];PJ[z]=J[k];
          z++;
          k++;PIlimit++;
        }
} /* for k */
for(j=0;j<PIlimit;j++){
for(i=0;i<N;i++){
if(m[PI[j]][i]==m[PJ[j]][i]){
  if(m[PI[j]][i]==0){ CPI[j][i]='0';}
  if(m[PI[j]][i]==1){ CPI[j][i]='1';}
}
else if(m[PI[j]][i]!=m[PJ[j]][i]){ CPI[j][i]='-';}
gotoxy(4+i,7+j);printf("%c",CPI[j][i]);
}
printf("\n");
}

/**************************** ESSENTIAL PI Table ***************************/

gotoxy(17,6);printf("EPI Table");
for(j=0;j<min_num;j++){ CNE[j]=0; }
for(k=0;k<PIlimit;k++){
for(j=0;j<min_num;j++){
  if(PI[k]<=MIN[j] && MIN[j]<=PJ[k]){
  f=0;
  for(i=0;i<N;i++){
if(m[PI[k]][i]*m[MIN[j]][i]==m[PI[k]][i]&&m[MIN[j]][i]*m[PJ[k]][i]==m[MIN[j]][i])
  {
   f++;
  }
  else {break;}
  }/* for i */
 }/* if */
else { continue ;}
if(f==N) {CNE[j]++;}
}/* for j */
}/* for z */
s=0;EPIlimit=0;
for(j=0;j<min_num;j++){
   if(CNE[j]!=1) {continue;}
 else if(CNE[j]==1){
      for(k=0;k<PIlimit;k++){
       if(MIN[j]>PJ[k] && MIN[j]<PI[k]){ continue; }
       else if(PI[k]<=MIN[j] && MIN[j]<=PJ[k]){
       f=0;
       for(i=0;i<N;i++){
if(m[PI[k]][i]*m[MIN[j]][i]==m[PI[k]][i]&&m[MIN[j]][i]*m[PJ[k]][i]==m[MIN[j]][i])
{
 f++;continue;
}
else { break; }
}/* for i */
if(f==N){
          if(s==0){
                    EPI[s]=PI[k];EPJ[s]=PJ[k];
                    s++;EPIlimit++;break;
                  }
           if(s>0){
                       g=0;
                       for(l=0;l<EPIlimit;l++){
                       if(EPI[l]==PI[k] && EPJ[l]==PJ[k]){ break;}
                       else{g++;continue;}
                       }
                     if(g==s){
                     EPI[s]=PI[k];EPJ[s]=PJ[k];
                     s++;EPIlimit++;break;
                     }
                  }
        }
}
} /* for k   */
} /* else if */
} /* for j   */
for(j=0;j<EPIlimit;j++){
for(i=0;i<N;i++){
if(m[EPI[j]][i]==m[EPJ[j]][i]){
 if(m[EPI[j]][i]==0){ CEPI[j][i]='0';}
 if(m[EPI[j]][i]==1){ CEPI[j][i]='1';}
}
else if(m[EPI[j]][i]!=m[EPJ[j]][i]){ CEPI[j][i]='-';}
gotoxy(17+i,7+j);printf("%c",CEPI[j][i]);
}
printf("\n");
}
for(j=0;j<min_num;j++){ CNNE[j]=0;}
for(k=0;k<EPIlimit;k++){
for(j=0;j<min_num;j++){
      if(EPI[k]>MIN[j]  || MIN[j]>EPJ[k]) { continue; }
 else if(EPI[k]<=MIN[j] && MIN[j]<=EPJ[k]){
 f=0;
 for(i=0;i<N;i++){
if(m[EPI[k]][i]*m[MIN[j]][i]==m[EPI[k]][i]&&m[MIN[j]][i]*m[EPJ[k]][i]==m[MIN[j]][i])
{
 f++;continue;
}
else {break;}
}/* for i */
if(f==N){ CNNE[j]++; }
}/*else if*/
}/* for j */
}/* for k */
/************************** Non-Essential PI table **************************/
gotoxy(30,6);printf("NEPI Table");
t=0;NEPIlimit=0;count=0;
for(j=0;j<min_num;j++){
if(CNNE[j]!=0){
count++;if(count==min_num){gotoxy(30,7);printf("*** NONE ***\n");break;}
                     else {continue;}
}
else if(CNNE[j]==0){
     for(k=0;k<PIlimit;k++){
      if(MIN[j]<PI[k] || MIN[j]>PJ[k]){continue;}
      else if(PI[k]<=MIN[j] && MIN[j]<=PJ[k]){
 f=0;
 for(i=0;i<N;i++){
if(m[PI[k]][i]*m[MIN[j]][i]==m[PI[k]][i]&&m[MIN[j]][i]*m[PJ[k]][i]==m[MIN[j]][i])
{
 f++;continue;
}
else{ break;}
}
if(f==N){
          if(t==0){
                    NEPI[t]=PI[k];NEPJ[t]=PJ[k];
                    t++;NEPIlimit++;break;
                  }
           if(t>0){ g=0;
                    for(l=0;l<t;l++){
                    if(NEPI[l]==PI[k] && NEPJ[l]==PJ[k]){break;}
                    else {g++;continue;}
                    }
                    if(g==t){
                              NEPI[t]=PI[k];NEPJ[t]=PJ[k];
                              t++;NEPIlimit++;break;
                             }
                  }
        }
} /* else if */
} /* for k   */
} /* else if */
} /* for j   */
for(j=0;j<NEPIlimit;j++){
for(i=0;i<N;i++){
if(m[NEPI[j]][i]==m[NEPJ[j]][i]){
 if(m[NEPI[j]][i]==0){ CNEPI[j][i]='0';}
 if(m[NEPI[j]][i]==1){ CNEPI[j][i]='1';}
}
else if(m[NEPI[j]][i]!=m[NEPJ[j]][i]){ CNEPI[j][i]='-';}
gotoxy(30+i,7+j);printf("%c",CNEPI[j][i]);
}
printf("\n");
}
/**************************** adding minterms *******************************/
gotoxy(45,6);printf("Minterms Adding");
count=0;counter=0;
 for(j=0;j<min_num;j++){
   if(CNE[j]==0){
   counter++;
      for(i=0;i<N;i++){
       gotoxy(45+i,7+j);printf("%d",m[MIN[j]][i]);
      if(m[MIN[j]][i]==1){CADM[j][i]='1';}
      if(m[MIN[j]][i]==0){CADM[j][i]='0';}
      }
   printf("\n");
   }
   else count++;
 }
if(count==min_num){gotoxy(45,7);printf("*** NONE ***\n");}
/******* presentation of simplified function using ascii characters *********/
term=0;
gotoxy(1,22);printf("SIMPLIFIED FORM IS\nF = ");
if(counter>0){
 for(j=0;j<min_num;j++){
  if(CNE[j]==0){
   for(i=0;i<N;i++){
    if(CADM[j][i]=='1'){printf("%c",toascii(65+i));}
    if(CADM[j][i]=='0'){printf("%c%c",toascii(65+i),toascii(39));}
   }
   term++;if(term==8){term=0;printf("\n  ");}
   printf("%c",toascii(43));
 }
 }
}
if(EPIlimit>0){
 for(j=0;j<EPIlimit;j++){
  if(j!=0){
            term++;if(term==8){term=0;printf("\n  ");}
            printf("%c",toascii(43));
}
   for(i=0;i<N;i++){
    if(CEPI[j][i]=='1'){printf("%c",toascii(65+i));}
    if(CEPI[j][i]=='0'){printf("%c%c",toascii(65+i),toascii(39));}
   }
 }
}
if(NEPIlimit>0){
 for(j=0;j<NEPIlimit;j++){
  term++;
  if(term==8){term=0;printf("\n  ");}
  printf("%c",toascii(43));
   for(i=0;i<N;i++){
    if(CNEPI[j][i]=='1'){printf("%c",toascii(65+i));}
    if(CNEPI[j][i]=='0'){printf("%c%c",toascii(65+i),toascii(39));}
   }
 }
}
if(counter==0 && EPIlimit==0 && NEPIlimit==0){
printf("No solution\a");
}
if(min_num+dont_num==pow(2,N)){
printf("1\n");
}
return 0;
} /* main */
/* [ EOF - Ahmet Bingul ] */